/*
  crossword -- a crossword game
  Copyright (C) 2000 Falk Hueffner

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA

  $Id: HumanPlayer.hh,v 1.1 2000/10/22 14:42:22 falk Exp $
*/

#ifndef HUMANPLAYER_HH
#define HUMANPLAYER_HH

#include <string>

#include "Board.hh"
#include "Move.hh"
#include "Player.hh"
#include "Tile.hh"

class HumanPlayer : public Player {
public:
    HumanPlayer(const string& name) : _name(name) { }

    string name() const { return _name; }
    
    void apply(const Move& move);
    Move getMove();

private:
    string _name;
    Board board;
};

#endif
