/*
  crossword -- a crossword game
  Copyright (C) 2000 Falk Hueffner

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA

  $Id: Trie.hh,v 1.6 2000/11/29 01:29:38 falk Exp $
*/

#ifndef TRIE_HH
#define TRIE_HH

#include <string>

#include "TrieNode.hh"

using namespace std;

class Trie {
public:
    Trie(const string& file);
    ~Trie();

    const TrieNode* root() const { return &nodes[0]; }

private:
    const TrieNode* nodes;
    size_t mapLength;
};

#endif
